/*
 * Copyright (c) 2017 SpaceToad and the BuildCraft team
 * This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not
 * distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/
 */

package buildcraft.lib.world;

import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Biomes;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.WorldType;
import net.minecraft.world.biome.Biome;

/** An {@link IBlockAccess} for getting the properties of a single {@link IBlockState}
 * at the {@link SingleBlockAccess#POS} */
public class SingleBlockAccess implements IBlockAccess {
    public static final BlockPos POS = BlockPos.field_177992_a;
    public final IBlockState state;

    public SingleBlockAccess(IBlockState state) {
        this.state = state;
    }

    @Override
    public TileEntity func_175625_s(BlockPos pos) {
        return null;
    }

    @Override
    public int func_175626_b(BlockPos pos, int lightValue) {
        return lightValue << 4;
    }

    @Override
    public IBlockState func_180495_p(BlockPos pos) {
        return POS.equals(pos) ? state : Blocks.field_150350_a.func_176223_P();
    }

    @Override
    public boolean func_175623_d(BlockPos pos) {
        return func_180495_p(pos).func_177230_c().isAir(state, this, pos);
    }

    @Override
    public Biome func_180494_b(BlockPos pos) {
        return Biomes.field_76772_c;
    }

    @Override
    public int func_175627_a(BlockPos pos, EnumFacing direction) {
        return 0;
    }

    @Override
    public WorldType func_175624_G() {
        return WorldType.field_180272_g;
    }

    @Override
    public boolean isSideSolid(BlockPos pos, EnumFacing side, boolean _default) {
        if (POS.equals(pos)) {
            return _default;
        }
        return state.isSideSolid(this, pos, side);
    }
}
